    001/*
    002 * Copyright (c) 2007-2017 Xplenty, Inc. All Rights Reserved.
    003 *
    004 * Project and contact information: http://www.cascading.org/
    005 *
    006 * This file is part of the Cascading project.
    007 *
    008 * Licensed under the Apache License, Version 2.0 (the "License");
    009 * you may not use this file except in compliance with the License.
    010 * You may obtain a copy of the License at
    011 *
    012 *     http://www.apache.org/licenses/LICENSE-2.0
    013 *
    014 * Unless required by applicable law or agreed to in writing, software
    015 * distributed under the License is distributed on an "AS IS" BASIS,
    016 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    017 * See the License for the specific language governing permissions and
    018 * limitations under the License.
    019 */
    020
    021package cascading.management.annotation;
    022
    023/**
    024 * Sanitizer is an interface to be used in conjunction with {@link PropertySanitizer}.
    025 * <p/>
    026 * The Sanitizer implementation has the option to provide a different value for each level of
    027 * {@link cascading.management.annotation.Visibility}.
    028 * <p/>
    029 * For example, if the raw value is an URL, the {@code PUBLIC} sanitized value may just include the URL path. The
    030 * {@code PROTECTED} value may retain the query string, and the {@code PRIVATE} value may retain the scheme and
    031 * domain name of the server.
    032 * <p/>
    033 * If a Sanitizer returns {@code null}, no value will be available for that requested visibility.
    034 * <p/>
    035 * Implementations of this interface must provide a default no-args Constructor.
    036 */
    037public interface Sanitizer
    038  {
    039  /**
    040   * Applies the custom sanitization to the given value for the given visibility.
    041   *
    042   * @param visibility The visibility of the property value.
    043   * @param value      The value to sanitize.
    044   * @return A sanitized version of the value.
    045   */
    046  String apply( Visibility visibility, Object value );
    047  }